diff --git src/video/cocoa/SDL_cocoawindow.m src/video/cocoa/SDL_cocoawindow.m
index 641df8129..40f559523 100644
--- src/video/cocoa/SDL_cocoawindow.m
+++ src/video/cocoa/SDL_cocoawindow.m
@@ -22,9 +22,9 @@
 
 #ifdef SDL_VIDEO_DRIVER_COCOA
 
-#if MAC_OS_X_VERSION_MAX_ALLOWED < 1070
-# error SDL for Mac OS X must be built with a 10.7 SDK or above.
-#endif /* MAC_OS_X_VERSION_MAX_ALLOWED < 1070 */
+#if MAC_OS_X_VERSION_MAX_ALLOWED < 1050
+# error SDL for Mac OS X must be built with a 10.5 SDK or above.
+#endif /* MAC_OS_X_VERSION_MAX_ALLOWED < 1050 */
 
 #include "SDL_syswm.h"
 #include "SDL_timer.h"  /* For SDL_GetTicks() */
@@ -62,8 +62,53 @@
 #define NSAppKitVersionNumber10_14      1671
 #endif
 
+/* The fullscreen-Spaces machinery is compiled in unconditionally, but is only
+ * ever exercised at runtime on 10.7+ (videodata.allow_spaces checks the OS
+ * version).  Old SDKs lack these constants and notification-name symbols;
+ * providing the raw values / literal strings keeps the code building, and the
+ * observers simply never fire on OS releases that never post them. */
+#ifndef MAC_OS_X_VERSION_10_6
+#define NSWindowCollectionBehaviorManaged (1 << 2)
+#define NSWindowWillStartLiveResizeNotification @"NSWindowWillStartLiveResizeNotification"
+#define NSWindowDidEndLiveResizeNotification @"NSWindowDidEndLiveResizeNotification"
+#endif
+#ifndef MAC_OS_X_VERSION_10_7
+#define NSWindowCollectionBehaviorFullScreenPrimary (1 << 7)
+#define NSWindowDidChangeBackingPropertiesNotification @"NSWindowDidChangeBackingPropertiesNotification"
+#define NSWindowWillEnterFullScreenNotification @"NSWindowWillEnterFullScreenNotification"
+#define NSWindowDidEnterFullScreenNotification @"NSWindowDidEnterFullScreenNotification"
+#define NSWindowWillExitFullScreenNotification @"NSWindowWillExitFullScreenNotification"
+#define NSWindowDidExitFullScreenNotification @"NSWindowDidExitFullScreenNotification"
+#endif
+
 @implementation SDL_WindowData
 
+@synthesize window = _window;
+@synthesize nswindow = _nswindow;
+@synthesize sdlContentView = _sdlContentView;
+@synthesize nscontexts = _nscontexts;
+@synthesize created = _created;
+@synthesize inWindowFullscreenTransition = _inWindowFullscreenTransition;
+@synthesize window_number = _window_number;
+@synthesize flash_request = _flash_request;
+@synthesize listener = _listener;
+@synthesize videodata = _videodata;
+#ifdef SDL_VIDEO_OPENGL_EGL
+@synthesize egl_surface = _egl_surface;
+#endif
+
+#if !SDL_COCOA_ARC
+- (void)dealloc
+{
+    [_nswindow release];
+    [_sdlContentView release];
+    [_nscontexts release];
+    [_listener release];
+    [_videodata release];
+    [super dealloc];
+}
+#endif
+
 @end
 
 @interface NSWindow (SDL)
@@ -75,7 +120,11 @@
 @property (nonatomic) NSRect mouseConfinementRect;
 @end
 
+#ifdef MAC_OS_X_VERSION_10_7 /* formal NSDraggingDestination protocol arrived with the 10.7 SDK */
 @interface SDLWindow : NSWindow <NSDraggingDestination>
+#else
+@interface SDLWindow : NSWindow
+#endif
 /* These are needed for borderless/fullscreen windows */
 - (BOOL)canBecomeKeyWindow;
 - (BOOL)canBecomeMainWindow;
@@ -158,7 +207,7 @@
 }
 
 - (BOOL)performDragOperation:(id <NSDraggingInfo>)sender
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     NSPasteboard *pasteboard = [sender draggingPasteboard];
     NSArray *types = [NSArray arrayWithObject:NSFilenamesPboardType];
@@ -194,6 +243,8 @@
 
     for (NSString *path in array) {
         NSURL *fileURL = [NSURL fileURLWithPath:path];
+
+#ifdef MAC_OS_X_VERSION_10_6 /* URL resource values and bookmarks arrived with the 10.6 SDK */
         NSNumber *isAlias = nil;
 
         [fileURL getResourceValue:&isAlias forKey:NSURLIsAliasFileKey error:nil];
@@ -214,6 +265,7 @@
                 }
             }
         }
+#endif
 
         if (!SDL_SendDropFile(sdlwindow, [[fileURL path] UTF8String])) {
             return NO;
@@ -335,12 +387,25 @@ static SDL_bool SetWindowStyle(SDL_Window * window, NSUInteger style)
     SDL_WindowData *data = (__bridge SDL_WindowData *) window->driverdata;
     NSWindow *nswindow = data.nswindow;
 
+#ifndef MAC_OS_X_VERSION_10_6
+    /* -[NSWindow setStyleMask:] arrived in 10.6; a 10.5 window keeps the
+       style it was created with. */
+    if (![nswindow respondsToSelector:@selector(setStyleMask:)]) {
+        return SDL_FALSE;
+    }
+#endif
+
     /* The view responder chain gets messed with during setStyleMask */
     if ([data.sdlContentView nextResponder] == data.listener) {
         [data.sdlContentView setNextResponder:nil];
     }
 
+#ifdef MAC_OS_X_VERSION_10_6
     [nswindow setStyleMask:style];
+#else
+    /* the NSUInteger argument rides in the pointer slot */
+    [nswindow performSelector:@selector(setStyleMask:) withObject:(id)(uintptr_t)style];
+#endif
 
     /* The view responder chain gets messed with during setStyleMask */
     if ([data.sdlContentView nextResponder] != data.listener) {
@@ -531,7 +596,9 @@ static NSCursor *Cocoa_GetDesiredCursor(void)
 
     [view setNextResponder:self];
 
+#ifdef MAC_OS_X_VERSION_10_6 /* -setAcceptsTouchEvents: arrived with the 10.6 SDK */
     [view setAcceptsTouchEvents:YES];
+#endif
 }
 
 - (void)observeValueForKeyPath:(NSString *)keyPath
@@ -921,7 +988,12 @@ static NSCursor *Cocoa_GetDesiredCursor(void)
         [NSMenu setMenuBarVisible:NO];
     }
     {
+#ifdef MAC_OS_X_VERSION_10_6 /* +[NSEvent modifierFlags] arrived with the 10.6 SDK */
         const unsigned int newflags = [NSEvent modifierFlags] & NSEventModifierFlagCapsLock;
+#else
+        /* same NX_* bit values as the AppKit modifier masks */
+        const unsigned int newflags = (unsigned int)CGEventSourceFlagsState(kCGEventSourceStateCombinedSessionState) & NSEventModifierFlagCapsLock;
+#endif
         _data.videodata.modifierFlags = (_data.videodata.modifierFlags & ~NSEventModifierFlagCapsLock) | newflags;
         SDL_ToggleModState(KMOD_CAPS, newflags ? SDL_TRUE : SDL_FALSE);
     }
@@ -951,6 +1023,7 @@ static NSCursor *Cocoa_GetDesiredCursor(void)
 
 - (void)windowDidChangeBackingProperties:(NSNotification *)aNotification
 {
+#ifdef MAC_OS_X_VERSION_10_7 /* backing scale factors arrived with the 10.7 SDK, and this never fires before 10.7 */
     NSNumber *oldscale = [[aNotification userInfo] objectForKey:NSBackingPropertyOldScaleFactorKey];
 
     if (inFullscreenTransition) {
@@ -963,6 +1036,7 @@ static NSCursor *Cocoa_GetDesiredCursor(void)
         _data.window->h = 0;
         [self windowDidResize:aNotification];
     }
+#endif
 }
 
 - (void)windowDidChangeScreenProfile:(NSNotification *)aNotification
@@ -1161,6 +1235,7 @@ static NSCursor *Cocoa_GetDesiredCursor(void)
     }
 }
 
+#ifdef MAC_OS_X_VERSION_10_7 /* fullscreen presentation options arrived with the 10.7 SDK */
 -(NSApplicationPresentationOptions)window:(NSWindow *)window willUseFullScreenPresentationOptions:(NSApplicationPresentationOptions)proposedOptions
 {
     if ((_data.window->flags & SDL_WINDOW_FULLSCREEN_DESKTOP) == SDL_WINDOW_FULLSCREEN_DESKTOP) {
@@ -1169,6 +1244,7 @@ static NSCursor *Cocoa_GetDesiredCursor(void)
         return proposedOptions;
     }
 }
+#endif
 
 /* We'll respond to key events by mostly doing nothing so we don't beep.
  * We could handle key messages here, but we lose some in the NSApp dispatch,
@@ -1455,6 +1531,7 @@ static int Cocoa_SendMouseButtonClicks(SDL_Mouse * mouse, NSEvent *theEvent, SDL
        with the SDL_HINT_TRACKPAD_IS_TOUCH_ONLY hint. */
     BOOL istrackpad = NO;
     if (!videodata.trackpad_is_touch_only) {
+#if defined(__clang__)
         @try {
             istrackpad = ([theEvent subtype] == NSEventSubtypeMouseEvent);
         }
@@ -1466,10 +1543,16 @@ static int Cocoa_SendMouseButtonClicks(SDL_Mouse * mouse, NSEvent *theEvent, SDL
              * *** Assertion failure in -[NSEvent subtype]
              */
         }
+#else
+        /* GCC would need -fobjc-exceptions for the @try above.  GCC builds
+         * only target Mac OS X 10.5-10.10, where -[NSEvent subtype] raises
+         * for gesture events, so the result would be NO there anyway. */
+#endif
     }
     return istrackpad;
 }
 
+#ifdef MAC_OS_X_VERSION_10_6 /* NSTouch and friends arrived with the 10.6 SDK */
 - (void)touchesBeganWithEvent:(NSEvent *) theEvent
 {
     NSSet *touches;
@@ -1579,6 +1662,7 @@ static int Cocoa_SendMouseButtonClicks(SDL_Mouse * mouse, NSEvent *theEvent, SDL
         }
     }
 }
+#endif /* MAC_OS_X_VERSION_10_6 */
 
 @end
 
@@ -1593,8 +1677,10 @@ static int Cocoa_SendMouseButtonClicks(SDL_Mouse * mouse, NSEvent *theEvent, SDL
 - (BOOL)mouseDownCanMoveWindow;
 - (void)drawRect:(NSRect)dirtyRect;
 - (BOOL)acceptsFirstMouse:(NSEvent *)theEvent;
+#ifdef MAC_OS_X_VERSION_10_7 /* the layer-backed path is 10.8+ only */
 - (BOOL)wantsUpdateLayer;
 - (void)updateLayer;
+#endif
 @end
 
 @implementation SDLView
@@ -1616,13 +1702,17 @@ static int Cocoa_SendMouseButtonClicks(SDL_Mouse * mouse, NSEvent *theEvent, SDL
     if ([NSGraphicsContext currentContext]) {
         [[NSColor blackColor] setFill];
         NSRectFill(dirtyRect);
+#ifdef MAC_OS_X_VERSION_10_7 /* pre-10.7 SDKs don't expose the CALayer interface via Cocoa.h */
     } else if (self.layer) {
         self.layer.backgroundColor = CGColorGetConstantColor(kCGColorBlack);
+#endif
     }
 
     SDL_SendWindowEvent(_sdlWindow, SDL_WINDOWEVENT_EXPOSED, 0, 0);
 }
 
+#ifdef MAC_OS_X_VERSION_10_7
+/* The updateLayer path is only taken by layer-backed views (10.8+). */
 - (BOOL)wantsUpdateLayer
 {
     return YES;
@@ -1638,6 +1728,7 @@ static int Cocoa_SendMouseButtonClicks(SDL_Mouse * mouse, NSEvent *theEvent, SDL
     ScheduleContextUpdates((__bridge SDL_WindowData *) _sdlWindow->driverdata);
     SDL_SendWindowEvent(_sdlWindow, SDL_WINDOWEVENT_EXPOSED, 0, 0);
 }
+#endif /* MAC_OS_X_VERSION_10_7 */
 
 - (void)rightMouseDown:(NSEvent *)theEvent
 {
@@ -1670,7 +1761,7 @@ static int Cocoa_SendMouseButtonClicks(SDL_Mouse * mouse, NSEvent *theEvent, SDL
 @end
 
 static int SetupWindowData(_THIS, SDL_Window * window, NSWindow *nswindow, NSView *nsview, SDL_bool created)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     SDL_VideoData *videodata = (__bridge SDL_VideoData *) _this->driverdata;
     SDL_WindowData *data;
@@ -1685,11 +1776,19 @@ static int SetupWindowData(_THIS, SDL_Window * window, NSWindow *nswindow, NSVie
     data.created = created;
     data.videodata = videodata;
     data.window_number = nswindow.windowNumber;
-    data.nscontexts = [[NSMutableArray alloc] init];
+    {
+        NSMutableArray *contexts = [[NSMutableArray alloc] init];
+        data.nscontexts = contexts;
+        SDL_COCOA_RELEASE(contexts); /* the property holds a reference */
+    }
     data.sdlContentView = nsview;
 
     /* Create an event listener for the window */
-    data.listener = [[Cocoa_WindowListener alloc] init];
+    {
+        Cocoa_WindowListener *listener = [[Cocoa_WindowListener alloc] init];
+        data.listener = listener;
+        SDL_COCOA_RELEASE(listener); /* the property holds a reference */
+    }
 
     /* Fill in the SDL window with the window data */
     {
@@ -1750,7 +1849,9 @@ static int SetupWindowData(_THIS, SDL_Window * window, NSWindow *nswindow, NSVie
      * it will also call [NSWindow close] in DestroyWindow before releasing the
      * NSWindow, so the extra release provided by releasedWhenClosed isn't
      * necessary. */
-    nswindow.releasedWhenClosed = NO;
+    /* bracket form: GCC's dot syntax can't resolve this without a declared
+       @property (the getter is named isReleasedWhenClosed) */
+    [nswindow setReleasedWhenClosed:NO];
 
     /* Prevents the window's "window device" from being destroyed when it is
      * hidden. See http://www.mikeash.com/pyblog/nsopenglcontext-and-one-shot.html
@@ -1758,12 +1859,13 @@ static int SetupWindowData(_THIS, SDL_Window * window, NSWindow *nswindow, NSVie
     [nswindow setOneShot:NO];
 
     /* All done! */
-    window->driverdata = (void *)CFBridgingRetain(data);
+    window->driverdata = SDL_CFBridgingRetain(data);
+    SDL_COCOA_RELEASE(data); /* the driverdata reference keeps it alive */
     return 0;
 }}
 
 int Cocoa_CreateWindow(_THIS, SDL_Window * window)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     SDL_VideoData *videodata = (__bridge SDL_VideoData *) _this->driverdata;
     NSWindow *nswindow;
@@ -1798,14 +1900,21 @@ int Cocoa_CreateWindow(_THIS, SDL_Window * window)
         }
     }
 
+#if defined(__clang__)
     @try {
         nswindow = [[SDLWindow alloc] initWithContentRect:rect styleMask:style backing:NSBackingStoreBuffered defer:NO screen:screen];
     }
     @catch (NSException *e) {
         return SDL_SetError("%s", [[e reason] UTF8String]);
     }
+#else
+    /* GCC would need -fobjc-exceptions for the @try above. */
+    nswindow = [[SDLWindow alloc] initWithContentRect:rect styleMask:style backing:NSBackingStoreBuffered defer:NO screen:screen];
+#endif
 
+#ifdef MAC_OS_X_VERSION_10_6 /* -setColorSpace: arrived with the 10.6 SDK */
     [nswindow setColorSpace:[NSColorSpace sRGBColorSpace]];
+#endif
 
 #if MAC_OS_X_VERSION_MAX_ALLOWED >= 101200 /* Added in the 10.12.0 SDK. */
     /* By default, don't allow users to make our window tabbed in 10.12 or later */
@@ -1838,8 +1947,12 @@ int Cocoa_CreateWindow(_THIS, SDL_Window * window)
     #endif
     /* Note: as of the macOS 10.15 SDK, this defaults to YES instead of NO when
      * the NSHighResolutionCapable boolean is set in Info.plist. */
+#ifdef MAC_OS_X_VERSION_10_7 /* Retina support arrived with the 10.7 SDK */
     highdpi = (window->flags & SDL_WINDOW_ALLOW_HIGHDPI) != 0;
     [contentView setWantsBestResolutionOpenGLSurface:highdpi];
+#else
+    (void) highdpi;
+#endif
     #ifdef __clang__
     #pragma clang diagnostic pop
     #endif
@@ -1853,10 +1966,13 @@ int Cocoa_CreateWindow(_THIS, SDL_Window * window)
 #endif /* SDL_VIDEO_OPENGL_EGL */
 #endif /* SDL_VIDEO_OPENGL_ES2 */
     [nswindow setContentView:contentView];
+    SDL_COCOA_RELEASE(contentView); /* the window and window data hold references */
 
     if (SetupWindowData(_this, window, nswindow, contentView, SDL_TRUE) < 0) {
+        SDL_COCOA_RELEASE(nswindow);
         return -1;
     }
+    SDL_COCOA_RELEASE(nswindow); /* the window data holds a reference */
 
     if (!(window->flags & SDL_WINDOW_OPENGL)) {
         return 0;
@@ -1880,7 +1996,7 @@ int Cocoa_CreateWindow(_THIS, SDL_Window * window)
 }}
 
 int Cocoa_CreateWindowFrom(_THIS, SDL_Window * window, const void *data)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     NSView* nsview = nil;
     NSWindow *nswindow = nil;
@@ -1910,8 +2026,12 @@ int Cocoa_CreateWindowFrom(_THIS, SDL_Window * window, const void *data)
     #endif
     /* Note: as of the macOS 10.15 SDK, this defaults to YES instead of NO when
      * the NSHighResolutionCapable boolean is set in Info.plist. */
+#ifdef MAC_OS_X_VERSION_10_7 /* Retina support arrived with the 10.7 SDK */
     highdpi = (window->flags & SDL_WINDOW_ALLOW_HIGHDPI) != 0;
     [nsview setWantsBestResolutionOpenGLSurface:highdpi];
+#else
+    (void) highdpi;
+#endif
     #ifdef __clang__
     #pragma clang diagnostic pop
     #endif
@@ -1920,16 +2040,16 @@ int Cocoa_CreateWindowFrom(_THIS, SDL_Window * window, const void *data)
 }}
 
 void Cocoa_SetWindowTitle(_THIS, SDL_Window * window)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     const char *title = window->title ? window->title : "";
     NSWindow *nswindow = ((__bridge SDL_WindowData *) window->driverdata).nswindow;
-    NSString *string = [[NSString alloc] initWithUTF8String:title];
+    NSString *string = SDL_COCOA_AUTORELEASE([[NSString alloc] initWithUTF8String:title]);
     [nswindow setTitle:string];
 }}
 
 void Cocoa_SetWindowIcon(_THIS, SDL_Window * window, SDL_Surface * icon)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     NSImage *nsimage = Cocoa_CreateImage(icon);
 
@@ -1939,7 +2059,7 @@ void Cocoa_SetWindowIcon(_THIS, SDL_Window * window, SDL_Surface * icon)
 }}
 
 void Cocoa_SetWindowPosition(_THIS, SDL_Window * window)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     SDL_WindowData *windata = (__bridge SDL_WindowData *) window->driverdata;
     NSWindow *nswindow = windata.nswindow;
@@ -1961,7 +2081,7 @@ void Cocoa_SetWindowPosition(_THIS, SDL_Window * window)
 }}
 
 void Cocoa_SetWindowSize(_THIS, SDL_Window * window)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     SDL_WindowData *windata = (__bridge SDL_WindowData *) window->driverdata;
     NSWindow *nswindow = windata.nswindow;
@@ -1987,7 +2107,7 @@ void Cocoa_SetWindowSize(_THIS, SDL_Window * window)
 }}
 
 void Cocoa_SetWindowMinimumSize(_THIS, SDL_Window * window)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     SDL_WindowData *windata = (__bridge SDL_WindowData *) window->driverdata;
 
@@ -1999,7 +2119,7 @@ void Cocoa_SetWindowMinimumSize(_THIS, SDL_Window * window)
 }}
 
 void Cocoa_SetWindowMaximumSize(_THIS, SDL_Window * window)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     SDL_WindowData *windata = (__bridge SDL_WindowData *) window->driverdata;
 
@@ -2011,15 +2131,17 @@ void Cocoa_SetWindowMaximumSize(_THIS, SDL_Window * window)
 }}
 
 void Cocoa_GetWindowSizeInPixels(_THIS, SDL_Window * window, int *w, int *h)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     SDL_WindowData *windata = (__bridge SDL_WindowData *) window->driverdata;
     NSView *contentView = windata.sdlContentView;
     NSRect viewport = [contentView bounds];
 
     if (window->flags & SDL_WINDOW_ALLOW_HIGHDPI) {
+#ifdef MAC_OS_X_VERSION_10_7 /* Retina support arrived with the 10.7 SDK */
         /* This gives us the correct viewport for a Retina-enabled view. */
         viewport = [contentView convertRectToBacking:viewport];
+#endif
     }
 
     *w = viewport.size.width;
@@ -2028,7 +2150,7 @@ void Cocoa_GetWindowSizeInPixels(_THIS, SDL_Window * window, int *w, int *h)
 
 
 void Cocoa_ShowWindow(_THIS, SDL_Window * window)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     SDL_WindowData *windowData = ((__bridge SDL_WindowData *) window->driverdata);
     NSWindow *nswindow = windowData.nswindow;
@@ -2041,7 +2163,7 @@ void Cocoa_ShowWindow(_THIS, SDL_Window * window)
 }}
 
 void Cocoa_HideWindow(_THIS, SDL_Window * window)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     NSWindow *nswindow = ((__bridge SDL_WindowData *) window->driverdata).nswindow;
 
@@ -2049,7 +2171,7 @@ void Cocoa_HideWindow(_THIS, SDL_Window * window)
 }}
 
 void Cocoa_RaiseWindow(_THIS, SDL_Window * window)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     SDL_WindowData *windowData = ((__bridge SDL_WindowData *) window->driverdata);
     NSWindow *nswindow = windowData.nswindow;
@@ -2066,7 +2188,7 @@ void Cocoa_RaiseWindow(_THIS, SDL_Window * window)
 }}
 
 void Cocoa_MaximizeWindow(_THIS, SDL_Window * window)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     SDL_WindowData *windata = (__bridge SDL_WindowData *) window->driverdata;
     NSWindow *nswindow = windata.nswindow;
@@ -2077,7 +2199,7 @@ void Cocoa_MaximizeWindow(_THIS, SDL_Window * window)
 }}
 
 void Cocoa_MinimizeWindow(_THIS, SDL_Window * window)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     SDL_WindowData *data = (__bridge SDL_WindowData *) window->driverdata;
     NSWindow *nswindow = data.nswindow;
@@ -2089,7 +2211,7 @@ void Cocoa_MinimizeWindow(_THIS, SDL_Window * window)
 }}
 
 void Cocoa_RestoreWindow(_THIS, SDL_Window * window)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     NSWindow *nswindow = ((__bridge SDL_WindowData *) window->driverdata).nswindow;
 
@@ -2101,7 +2223,7 @@ void Cocoa_RestoreWindow(_THIS, SDL_Window * window)
 }}
 
 void Cocoa_SetWindowBordered(_THIS, SDL_Window * window, SDL_bool bordered)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     if (SetWindowStyle(window, GetWindowStyle(window))) {
         if (bordered) {
@@ -2111,7 +2233,7 @@ void Cocoa_SetWindowBordered(_THIS, SDL_Window * window, SDL_bool bordered)
 }}
 
 void Cocoa_SetWindowResizable(_THIS, SDL_Window * window, SDL_bool resizable)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     /* Don't set this if we're in a space!
      * The window will get permanently stuck if resizable is false.
@@ -2135,7 +2257,7 @@ void Cocoa_SetWindowResizable(_THIS, SDL_Window * window, SDL_bool resizable)
 }}
 
 void Cocoa_SetWindowAlwaysOnTop(_THIS, SDL_Window * window, SDL_bool on_top)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
     {
         NSWindow *nswindow = ((__bridge SDL_WindowData *) window->driverdata).nswindow;
         if (on_top) {
@@ -2146,7 +2268,7 @@ void Cocoa_SetWindowAlwaysOnTop(_THIS, SDL_Window * window, SDL_bool on_top)
     }}
 
 void Cocoa_SetWindowFullscreen(_THIS, SDL_Window * window, SDL_VideoDisplay * display, SDL_bool fullscreen)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     SDL_WindowData *data = (__bridge SDL_WindowData *) window->driverdata;
     NSWindow *nswindow = data.nswindow;
@@ -2177,7 +2299,13 @@ void Cocoa_SetWindowFullscreen(_THIS, SDL_Window * window, SDL_VideoDisplay * di
             }
         }
 
+#ifdef MAC_OS_X_VERSION_10_6
         [nswindow setStyleMask:NSWindowStyleMaskBorderless];
+#else
+        if ([nswindow respondsToSelector:@selector(setStyleMask:)]) {
+            [nswindow performSelector:@selector(setStyleMask:) withObject:(id)(uintptr_t)NSWindowStyleMaskBorderless];
+        }
+#endif
     } else {
         NSRect frameRect;
         rect.origin.x = window->windowed.x;
@@ -2192,7 +2320,13 @@ void Cocoa_SetWindowFullscreen(_THIS, SDL_Window * window, SDL_VideoDisplay * di
          * macOS 10.15 where the window doesn't properly restore the windowed
          * mode decorations after exiting fullscreen-desktop, when the window
          * was created as fullscreen-desktop. */
+#ifdef MAC_OS_X_VERSION_10_6
         [nswindow setStyleMask:GetWindowWindowedStyle(window)];
+#else
+        if ([nswindow respondsToSelector:@selector(setStyleMask:)]) {
+            [nswindow performSelector:@selector(setStyleMask:) withObject:(id)(uintptr_t)GetWindowWindowedStyle(window)];
+        }
+#endif
 
         /* Hack to restore window decorations on Mac OS X 10.10 */
         frameRect = [nswindow frame];
@@ -2234,7 +2368,7 @@ void Cocoa_SetWindowFullscreen(_THIS, SDL_Window * window, SDL_VideoDisplay * di
 }}
 
 int Cocoa_SetWindowGammaRamp(_THIS, SDL_Window * window, const Uint16 * ramp)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     SDL_VideoDisplay *display = SDL_GetDisplayForWindow(window);
     CGDirectDisplayID display_id = ((SDL_DisplayData *)display->driverdata)->display;
@@ -2260,8 +2394,12 @@ int Cocoa_SetWindowGammaRamp(_THIS, SDL_Window * window, const Uint16 * ramp)
 }}
 
 void *Cocoa_GetWindowICCProfile(_THIS, SDL_Window * window, size_t * size)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
+#ifndef MAC_OS_X_VERSION_10_6 /* -[NSScreen colorSpace] arrived with the 10.6 SDK */
+    SDL_Unsupported();
+    return NULL;
+#else
     SDL_WindowData *data = (__bridge SDL_WindowData *) window->driverdata;
     NSWindow *nswindow = data.nswindow;
     NSScreen *screen = [nswindow screen];
@@ -2293,10 +2431,11 @@ void *Cocoa_GetWindowICCProfile(_THIS, SDL_Window * window, size_t * size)
     [iccProfileData getBytes:retIccProfileData length:[iccProfileData length]];
     *size = [iccProfileData length];
     return retIccProfileData;
+#endif /* MAC_OS_X_VERSION_10_6 */
 }}
 
 int Cocoa_GetWindowDisplayIndex(_THIS, SDL_Window * window)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     NSScreen *screen;
     SDL_WindowData *data = (__bridge SDL_WindowData *) window->driverdata;
@@ -2362,7 +2501,7 @@ void Cocoa_SetWindowMouseRect(_THIS, SDL_Window * window)
 }
 
 void Cocoa_SetWindowMouseGrab(_THIS, SDL_Window * window, SDL_bool grabbed)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     SDL_WindowData *data = (__bridge SDL_WindowData *) window->driverdata;
 
@@ -2383,9 +2522,9 @@ void Cocoa_SetWindowMouseGrab(_THIS, SDL_Window * window, SDL_bool grabbed)
 }}
 
 void Cocoa_DestroyWindow(_THIS, SDL_Window * window)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
-    SDL_WindowData *data = (SDL_WindowData *) CFBridgingRelease(window->driverdata);
+    SDL_WindowData *data = (SDL_WindowData *) SDL_CFBridgingRelease(window->driverdata);
 
     if (data) {
 #ifdef SDL_VIDEO_OPENGL
@@ -2397,22 +2536,26 @@ void Cocoa_DestroyWindow(_THIS, SDL_Window * window)
         }
         [data.listener close];
         data.listener = nil;
-        if (data.created) {
-            /* Release the content view to avoid further updateLayer callbacks */
-            [data.nswindow setContentView:nil];
-            [data.nswindow close];
-        }
 
 #ifdef SDL_VIDEO_OPENGL
-        contexts = [data.nscontexts copy];
+        /* Detach any GL contexts before tearing down the window: closing it
+           (or clearing its content view) with a context still attached makes
+           old OS X log "invalid drawable". */
+        contexts = SDL_COCOA_AUTORELEASE([data.nscontexts copy]);
         for (SDLOpenGLContext *context in contexts) {
             /* Calling setWindow:NULL causes the context to remove itself from the context list. */
             [context setWindow:NULL];
         }
 #endif /* SDL_VIDEO_OPENGL */
 
+        if (data.created) {
+            /* Release the content view to avoid further updateLayer callbacks */
+            [data.nswindow setContentView:nil];
+            [data.nswindow close];
+        }
+
         if (window->shaper) {
-            CFBridgingRelease(window->shaper->driverdata);
+            (void) SDL_CFBridgingRelease(window->shaper->driverdata);
             SDL_free(window->shaper);
             window->shaper = NULL;
         }
@@ -2421,7 +2564,7 @@ void Cocoa_DestroyWindow(_THIS, SDL_Window * window)
 }}
 
 SDL_bool Cocoa_GetWindowWMInfo(_THIS, SDL_Window * window, SDL_SysWMinfo * info)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     NSWindow *nswindow = ((__bridge SDL_WindowData *) window->driverdata).nswindow;
 
@@ -2437,7 +2580,7 @@ SDL_bool Cocoa_GetWindowWMInfo(_THIS, SDL_Window * window, SDL_SysWMinfo * info)
 }}
 
 SDL_bool Cocoa_IsWindowInFullscreenSpace(SDL_Window * window)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     SDL_WindowData *data = (__bridge SDL_WindowData *) window->driverdata;
 
@@ -2449,7 +2592,7 @@ SDL_bool Cocoa_IsWindowInFullscreenSpace(SDL_Window * window)
 }}
 
 SDL_bool Cocoa_SetWindowFullscreenSpace(SDL_Window * window, SDL_bool state)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     SDL_bool succeeded = SDL_FALSE;
     SDL_WindowData *data = (__bridge SDL_WindowData *) window->driverdata;
@@ -2496,18 +2639,23 @@ int Cocoa_SetWindowHitTest(SDL_Window * window, SDL_bool enabled)
 }
 
 void Cocoa_AcceptDragAndDrop(SDL_Window * window, SDL_bool accept)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     SDL_WindowData *data = (__bridge SDL_WindowData *) window->driverdata;
     if (accept) {
+#ifdef MAC_OS_X_VERSION_10_6
         [data.nswindow registerForDraggedTypes:[NSArray arrayWithObject:(NSString *)kUTTypeFileURL]];
+#else
+        /* pre-UTI drag types; performDragOperation reads NSFilenamesPboardType either way */
+        [data.nswindow registerForDraggedTypes:[NSArray arrayWithObject:NSFilenamesPboardType]];
+#endif
     } else {
         [data.nswindow unregisterDraggedTypes];
     }
 }}
 
 int Cocoa_FlashWindow(_THIS, SDL_Window *window, SDL_FlashOperation operation)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     /* Note that this is app-wide and not window-specific! */
     SDL_WindowData *data = (__bridge SDL_WindowData *) window->driverdata;
@@ -2534,7 +2682,7 @@ int Cocoa_FlashWindow(_THIS, SDL_Window *window, SDL_FlashOperation operation)
 }}
 
 int Cocoa_SetWindowOpacity(_THIS, SDL_Window * window, float opacity)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     SDL_WindowData *data = (__bridge SDL_WindowData *) window->driverdata;
     [data.nswindow setAlphaValue:opacity];
